mmme<-function(data, prox.loc, w=diag(1, nrow=((sum(nm)+1)*(sum(nm)+2)/2), ncol=((sum(nm)+1)*(sum(nm)+2)/2)), latent.names=NULL,  opt=TRUE, report.contr=FALSE, var.first=TRUE, cluster=FALSE, disp=TRUE) {
#definitions
ret<-list()
N<-dim(data)[1]
np<-length(prox.loc)-1
nm<-rep(NA,np)
for (i in 1:np) {
nm[i]<-prox.loc[i+1]-prox.loc[i]
}
nc<-ncol(data)-(sum(nm)+1)
ret$stats<-list(N=N,np=np,nm=nm)

#yulizing stuff
ydata<-matrix(NA,ncol=ncol(data),nrow=N)
if (prox.loc[np+1]>ncol(data)) {
Intercept<-rep(1,N)
a<-lm((data[,1])~Intercept-1)
ydata[,1]<-as.vector(residuals(a))
out.contr<-coef(summary(a))
colnames(out.contr)[4]<-"P-Value"
for (i in 1:sum(nm)) {
a<-lm(data[,(1+i)]~Intercept-1)
ydata[,(1+i)]<-residuals(a)
if (report.contr==TRUE) {
assign(paste("prox.contr",i,sep=""), coef(summary(a)))
}
}
} else {
X<-data[,(prox.loc[np+1]):ncol(data)]
a<-lm((data[,1])~X)
ydata[,1]<-as.vector(residuals(a))
out.contr<-coef(summary(a))
colnames(out.contr)[4]<-"P-Value"
for (i in 1:sum(nm)) {
a<-lm(data[,(1+i)]~X)
ydata[,(1+i)]<-residuals(a)
if (report.contr==TRUE) {
assign(paste("prox.contr",i,sep=""), coef(summary(a)))
}
}
}
dimnames(ydata)<-dimnames(data)

min.first<-nlm(loss,rep(1,1+(np+1)*np/2+2*sum(nm)),data=ydata,w=w,np=np,nm=nm,iterlim=1000)
ret$first<-min.first
param<-min.first$estimate
if (var.first==TRUE | opt==FALSE) {
var.cov.first<-varmat(param,ydata,w,np,nm,opt=FALSE,cluster=cluster)
ret$varfirst<-var.cov.first
}

if (opt==FALSE) {
if (disp==FALSE) return(ret)
#Wald Test
wt<-pchisq(t(param)%*%solve(var.cov.first)%*%param,length(param), lower.tail=FALSE)
ret$stats$waldp<-wt

#arrange output
se<-sqrt(diag(var.cov.first))
tstats<-param/se
pvalue<-2*pt(abs(tstats),(N-length(param)-nc-1), lower.tail=FALSE)
out<-cbind(param, se, tstats, pvalue)
colnames(out)<-c("Coefficient","SE", "t-statistic", "p-value")

out.coeff<-rbind(out[1:np,],abs(out[(np+1)*np/2+sum(nm)+1,]))
if (length(latent.names)==np) {
latent.names<-c(latent.names, "SD of Error in Outcome Equation")
rownames(out.coeff)<-latent.names
} else {
rownames(out.coeff)[np+1]<-"SD of Error in Outcome Equation"
rownames(out.coeff)[1:np]<-rownames(out.coeff[1:np], do.NULL=FALSE, prefix="Latent Variable ")
}

if (np>1) {
covariances<-out[(np+1):((np+1)*np/2),]
if (length(covariances)>4) {
a<-rep(NA,nrow(covariances))
row<-1
for (i in 1:(np-1)) {
for (j in (i+1):np) {
a[row]<-paste("Covariance",rownames(out.coeff)[i],rownames(out.coeff)[j])
row<-row+1
}
}
rownames(covariances)<-a
}
}

sds<-out[((np+1)*np/2+sum(nm)+2):length(param),]
sds[,c(1,3)]<-abs(sds[,c(1,3)])
colnames(sds)[1]<-"SD of Error in Proxy equation"
rownames(sds)<-colnames(data)[2:(1+sum(nm))]

prox.coeff<-cbind(out[((np+1)*np/2+1):((np+1)*np/2+sum(nm)),], sds)

#display
print("Results from estimation by GMM", quote=FALSE)
print("",quote=FALSE)
print("Outcome Equation", quote=FALSE)
print(formatC(as.table(out.coeff), format="f", digits=7))

if (np>1) {
print("",quote=FALSE)
print("",quote=FALSE)
print("Covariances between latent Variables", quote=FALSE)
print(formatC(as.table(covariances), format="f", digits=7))
}

print("",quote=FALSE)
print("",quote=FALSE)
print("Proxy Equations", quote=FALSE)
for (i in 1:np) {
a<-prox.coeff[(sum(nm[1:i])-nm[i]+1):sum(nm[1:i]),]
rownames(a)<-rownames(a, do.NULL=FALSE, prefix="Proxy")
print(rownames(out.coeff)[i], quote=FALSE)
print(formatC(as.table(a), format="f", digits=7))
print("",quote=FALSE)
}
print("Controls", quote=FALSE)
print("", quote=FALSE)
print("Coefficients of Controls in Outcome Equation", quote=FALSE)
print(formatC(as.table(out.contr), format="f", digits=7))

if (report.contr==TRUE) {
print("", quote=FALSE)
print("Coefficients from yulizing Proxies", quote=FALSE)
for (i in 1:sum(nm)) {
if (is.null(colnames(data)[1+i])==TRUE) print(paste("Proxy #",i), quote=FALSE) else print(rownames(data)[1+i], quote=FALSE)
print(formatC(as.table(get(paste("prox.contr",i,sep=""))),format="f", digits=7), quote=FALSE)
}
}
print(paste("P-value of Wald test of H0 that all coefficients (excluding controls) are jointly zero:",round(wt,digits=5)), quote=FALSE)
if (min.first$code>2) print("Warning: First step minimization may not have converged. See min.first$code and ?nlm for details", quote=FALSE)
return(invisible(ret))
}


if (opt==TRUE) {
sh<-s.hat(param,ydata,np=np,nm=nm,cluster=cluster)
min.opt<-nlm(loss,param,data=ydata,w=solve(sh),np=np,nm=nm,iterlim=1000)
ret$opt<-min.opt
if (disp==FALSE) return(invisible(ret))
param.opt<-min.opt$estimate
try(var.cov.opt<-varmat(param.opt,ydata,np=np,nm=nm,opt=TRUE,cluster=cluster))
if (exists("var.cov.opt")==0) {
verr<-.Last.value[]
var.cov.opt<-matrix(NA,length(param.opt),length(param.opt))
}
ret$varopt<-var.cov.opt

#tests
#OIR
oir<-pchisq(min.opt$minimum,(sum(nm)+1)*(sum(nm)+2)/2-length(param.opt), lower.tail=FALSE)
ret$stats$oir<-oir
#Wald Test
wt<-pchisq(t(param.opt)%*%solve(var.cov.opt)%*%param.opt,length(param.opt), lower.tail=FALSE)
ret$stats$waldp<-wt
#Hausman Test (note: could be wrong)
if (var.first==TRUE) {
param.ht<-param
for (i in 1:length(param)) {
if (sign(param[i])!=sign(param.opt[i])) param.ht[i]<-(-1)*param.ht[i]
}
var.haus<-varmat(param.ht,ydata,w,np=np,nm=nm,cluster=cluster)-var.cov.opt
if (any(diag(var.haus)<=0)==TRUE) ht<-"neg" else ht<-pchisq(t(param.opt-param.ht)%*%solve(var.haus)%*%(param.opt-param.ht),qr(var.cov.first-var.cov.opt)$rank, lower.tail=FALSE)
ret$stats$hausp<-ht
}

#arrange output
se<-sqrt(diag(var.cov.opt))
tstats<-param.opt/se
pvalue<-2*pt(abs(tstats),(N-length(param.opt)-nc-1), lower.tail=FALSE)
out<-cbind(param.opt, se, tstats, pvalue)
colnames(out)<-c("Coefficient","SE", "t-statistic", "p-value")

out.coeff<-rbind(out[1:np,],abs(out[(np+1)*np/2+sum(nm)+1,]))
if (length(latent.names)==np) {
latent.names<-c(latent.names, "SD of Error in Outcome Equation")
rownames(out.coeff)<-latent.names
} else {
rownames(out.coeff)[np+1]<-"SD of Error in Outcome Equation"
rownames(out.coeff)[1:np]<-rownames(out.coeff[1:np], do.NULL=FALSE, prefix="Latent Variable ")
}

if (np>1) {
covariances<-out[(np+1):((np+1)*np/2),]
if (length(covariances)>4) {
a<-rep(NA,nrow(covariances))
row<-1
for (i in 1:(np-1)) {
for (j in (i+1):np) {
a[row]<-paste("Covariance",rownames(out.coeff)[i],rownames(out.coeff)[j])
row<-row+1
}
}
rownames(covariances)<-a
}
}

sds<-out[((np+1)*np/2+sum(nm)+2):length(param.opt),]
sds[,c(1,3)]<-abs(sds[,c(1,3)])
colnames(sds)[1]<-"SD of Error in Proxy equation"
rownames(sds)<-colnames(data)[2:(1+sum(nm))]

prox.coeff<-cbind(out[((np+1)*np/2+1):((np+1)*np/2+sum(nm)),], sds)

#display
print("Results from estimation by optimally weighted GMM", quote=FALSE)
print("",quote=FALSE)
print("Outcome Equation", quote=FALSE)
print(formatC(as.table(out.coeff), format="f", digits=7))

if (np>1) {
print("",quote=FALSE)
print("",quote=FALSE)
print("Covariances between latent Variables", quote=FALSE)
print(formatC(as.table(covariances), format="f", digits=7))
}

print("",quote=FALSE)
print("",quote=FALSE)
print("Proxy Equations", quote=FALSE)
for (i in 1:np) {
a<-prox.coeff[(sum(nm[1:i])-nm[i]+1):sum(nm[1:i]),]
rownames(a)<-rownames(a, do.NULL=FALSE, prefix="Proxy")
print(rownames(out.coeff)[i], quote=FALSE)
print(formatC(as.table(a), format="f", digits=7))
print("",quote=FALSE)
}
print("Controls", quote=FALSE)
print("", quote=FALSE)
print("Coefficients of Controls in Outcome Equation", quote=FALSE)
print("Note that these are the coefficients from the yulizing step and are thus likely to be biased estimates of the coefficients in the model", quote=FALSE)
print(formatC(as.table(out.contr), format="f", digits=7))

if (report.contr==TRUE) {
print("", quote=FALSE)
print("Coefficients from yulizing Proxies", quote=FALSE)
for (i in 1:sum(nm)) {
if (is.null(colnames(data)[1+i])==TRUE) print(paste("Proxy #",i), quote=FALSE) else print(rownames(data)[1+i], quote=FALSE)
print(formatC(as.table(get(paste("prox.contr",i,sep=""))),format="f", digits=7), quote=FALSE)
}
}
print(paste("P-value of Wald test of H0 that all coefficients (excluding controls) are jointly zero:",round(wt, digits=5)), quote=FALSE)
if (min.first$code>2) print("Warning: First step minimization may not have converged. See min.first$code and ?nlm for details", quote=FALSE)
if (min.opt$code>2) print("Warning: Optimal GMM minimization may not have converged. See min.opt$code and ?nlm for details", quote=FALSE)
if (oir<=0.05) print(paste("Warning: OIR-test rejects H0 that moment restrictions are valid with p-value of",round(oir, digits=5)), quote=FALSE)
if (oir>0.05) print(paste("OIR-test does not reject H0 that moment restrictions are valid (p-value: ",round(oir, digits=5),")", sep=""), quote=FALSE)
if (var.first==TRUE) {
if (ht=="neg") print("Hausman test not possible since one of the OGMM variances is bigger than the corresponding GMM Variance", quote=FALSE) else {
if (ht<=0.05) print(paste("Warning: Hausman test rejects H0 of no small sample bias with p-value of",round(ht, digits=5)), quote=FALSE)
if (ht>0.05) print(paste("Hausman test does not reject H0 of no small sample bias (p-value: ",round(ht, digits=5),")", sep=""),quote=FALSE)
print("Note: Results of Hausman test above should be taken with caution since my coding may be wrong and fails in some circumstances. See Notes for further details.", quote=FALSE)
}
}
if (exists("verr")==1) {
print("The following error occured while computing the OGMM variance Matrix:",quote=FALSE)
print(verr,quote=FALSE)
}
return(invisible(ret))
}

}


###Auxilary Functions
#loss function
loss<-function(param,data, w=diag(1, nrow=length(v), ncol=length(v)),np,nm) {
N<-dim(data)[1]

cov.mat<-cov(data)

#define and arrange coefficients
out.coeff<-param[1:np]
ifelse(np>1,covariances<-param[(np+1):((np+1)*np/2)],covariances<-0)
covm<-matrix(NA, nrow=np, ncol=np)
if (np>1) {
j<-1
k<-np-1
for (i in 1:(np-1)) {
covm[i,(i+1):np]<-covariances[j:(j+k-1)]
covm[(i+1):np,i]<-covariances[j:(j+k-1)]
j<-j+k
k<-k-1
}
} else (covm[1,1]<-0)
row<-(np+1)*np/2
for (i in 1:np) {
assign(paste("prox.coeff",i,sep=""),param[(row+1):(row+nm[i])])
row<-row+nm[i]
}
sds<-param[(row+1):(row+ncol(cov.mat))]

##create vector of moment conditions
v<-rep(NA,((sum(nm)+1)*(sum(nm)+2)/2))
#Var(y)
if (np>1) {
vy<-rep(NA, (np+length(covariances)))
vy[1:np]<-out.coeff^2
if (np>1) {
row<-np+1
for (i in 1:(np-1)) {
for (j in (i+1):np) {
vy[row]<-2*out.coeff[i]*out.coeff[j]*covariances[row-np]
row<-row+1
}
}
}
v[1]<-sum(vy)+sds[1]^2-cov.mat[1,1]
} else v[1]<-out.coeff^2+sds[1]^2-cov.mat[1,1]

#Cov(y,proxies)
row<-2
for (i in 1:np) {
for (j in 1:nm[i]) {
vy<-rep(NA,np)
for (h in 1:np) {
coef<-paste("prox.coeff",i, sep="")
if (i==h) vy[h]<-out.coeff[h]*get(coef)[j]
else {
vy[h]<-out.coeff[h]*get(coef)[j]*covm[i,h]
}
}
v[row]<-sum(vy)-cov.mat[1,row]
row<-row+1
}
}

#Cov(proxies,proxies)
i<-1
for (h in 1:(sum(nm))) {
col<-h
if (h>(sum(nm[1:i]))) i<-i+1
coef<-paste("prox.coeff",i, sep="")
v[row]<-(get(coef)[h-(sum(nm[1:i])-nm[i])])^2+sds[h+1]^2-cov.mat[(h+1),(h+1)]
row<-row+1
col<-col+1
if (h-(sum(nm[1:i])-nm[i])+1<=nm[i]) {
for (j in (h-(sum(nm[1:i])-nm[i])+1):nm[i]) {
v[row]<-get(coef)[h-(sum(nm[1:i])-nm[i])]*get(coef)[j]-cov.mat[h+1,col+1]
row<-row+1
col<-col+1
}
}
if (i+1<=np) {
for (k in (i+1):np) {
coef2<-paste("prox.coeff",k, sep="")
for (l in 1:nm[k]) {
v[row]<-get(coef)[h-(sum(nm[1:i])-nm[i])]*get(coef2)[l]*covm[i,k]-cov.mat[h+1,col+1]
row<-row+1
col<-col+1
}
}
}
}
v<-v
dev<-t(v)%*%w%*%v
return(dev)
}

#S-Matrix
s.hat<-function(param,data,np,nm,cluster=FALSE) {
N<-dim(data)[1]

#define and arrange coefficients
out.coeff<-param[1:np]
ifelse(np>1,covariances<-param[(np+1):((np+1)*np/2)],covariances<-vector(length=0))
covm<-matrix(NA, nrow=np, ncol=np)
if (np>1) {
j<-1
k<-np-1
for (i in 1:(np-1)) {
covm[i,(i+1):np]<-covariances[j:(j+k-1)]
covm[(i+1):np,i]<-covariances[j:(j+k-1)]
j<-j+k
k<-k-1
}
} else (covm[1,1]<-0)
row<-(np+1)*np/2
for (i in 1:np) {
assign(paste("prox.coeff",i,sep=""),param[(row+1):(row+nm[i])])
row<-row+nm[i]
}
sds<-param[(row+1):(row+ncol(data))]

##create vector of theoretical moments
v<-rep(NA,((sum(nm)+1)*(sum(nm)+2)/2))
#Var(y)
vy<-rep(NA, (np+length(covariances)))
vy[1:np]<-out.coeff^2
row<-np+1
if (np>1) {
for (i in 1:(np-1)) {
for (j in (i+1):np) {
vy[row]<-2*out.coeff[i]*out.coeff[j]*covariances[row-np]
row<-row+1
}
}
}
v[1]<-sum(vy)+sds[1]^2

#Cov(y,proxies)
row<-2
for (i in 1:np) {
for (j in 1:nm[i]) {
vy<-rep(NA,np)
for (h in 1:np) {
coef<-paste("prox.coeff",i, sep="")
if (i==h) vy[h]<-out.coeff[h]*get(coef)[j]
else {
vy[h]<-out.coeff[h]*get(coef)[j]*covm[i,h]
}
}
v[row]<-sum(vy)
row<-row+1
}
}

#Cov(proxies,proxies)
i<-1
for (h in 1:(sum(nm))) {
col<-h
if (h>(sum(nm[1:i]))) i<-i+1
coef<-paste("prox.coeff",i, sep="")
v[row]<-(get(coef)[h-(sum(nm[1:i])-nm[i])])^2+sds[h+1]^2
row<-row+1
col<-col+1
if (h-(sum(nm[1:i])-nm[i])+1<=nm[i]) {
for (j in (h-(sum(nm[1:i])-nm[i])+1):nm[i]) {
v[row]<-get(coef)[h-(sum(nm[1:i])-nm[i])]*get(coef)[j]
row<-row+1
col<-col+1
}
}
if (i+1<=np) {
for (k in (i+1):np) {
coef2<-paste("prox.coeff",k, sep="")
for (l in 1:nm[k]) {
v[row]<-get(coef)[h-(sum(nm[1:i])-nm[i])]*get(coef2)[l]*covm[i,k]
row<-row+1
col<-col+1
}
}
}
}

##create vector of empirical moments for every observation
l<-matrix(0,(sum(nm)+1),(sum(nm)+1))
vm<-apply(data[,1:(sum(nm)+1)],1,function(x) v-(x%*%t(x))[lower.tri(l,diag=TRUE)])

if (cluster[1]==FALSE) {
sh<-apply(outer(t(vm),vm)[1,,,],c(1,2),sum)
} else if (sum(is.na(cluster))==0 & length(cluster)==N) { 
sh<-matrix(rowSums(apply(rbind(vm,cluster),2,function(x) if(is.null(dim(vm[,cluster==x[length(x)]]))) {outer(x[1:(length(x)-1)],vm[,cluster==x[length(x)]])} else {rowSums(outer(x[1:(length(x)-1)],vm[,cluster==x[length(x)]]),dims=2)})),nrow=((sum(nm)+1)*(sum(nm)+2)/2),ncol=((sum(nm)+1)*(sum(nm)+2)/2))
} else stop ("Warning: option cluster needs to be a vector of lenght N or FALSE")
return(invisible((1/N)*sh))
}

#Variance-Covariance Matrix
varmat<-function(param, data, w=diag(1, nrow=((sum(nm)+1)*(sum(nm)+2)/2), ncol=((sum(nm)+1)*(sum(nm)+2)/2)), np, nm, opt=FALSE, cluster=FALSE) {
N<-dim(data)[1]

#define and arrange coefficients
out.coeff<-param[1:np]
ifelse(np>1,covariances<-param[(np+1):((np+1)*np/2)],covariances<-vector(length=0))
covm<-matrix(0, nrow=np, ncol=np)
if (np>1) {
j<-1
k<-np-1
for (i in 1:(np-1)) {
covm[i,(i+1):np]<-covariances[j:(j+k-1)]
covm[(i+1):np,i]<-covariances[j:(j+k-1)]
j<-j+k
k<-k-1
}
}
row<-(np+1)*np/2
for (i in 1:np) {
assign(paste("prox.coeff",i,sep=""),param[(row+1):(row+nm[i])])
row<-row+nm[i]
}
sds<-param[(row+1):(row+ncol(data))]

##Ghat matrix
gh<-matrix(0, ncol=length(param), nrow=(sum(nm)+1)*(sum(nm)+2)/2)
#first row
for (i in 1:np) {
vy<-rep(NA, np)
for (j in 1:np) {
vy[j]<-2*out.coeff[j]*covm[i,j]
}
gh[1,i]<-2*out.coeff[i]+sum(vy)
}
col<-2
row<-1
if (np>1) {
for (i in 1:length(covariances)) {
if (col>np) {
row<-row+1
col<-row+1
}
gh[1,(np+i)]<-2*out.coeff[row]*out.coeff[col]
col<-col+1
}
}
gh[1,(np+length(covariances)+sum(nm)+1)]<-2*sds[1]

#Cov(y,proxies)
row<-2
for (i in 1:np) {
coef<-paste("prox.coeff",i,sep="")
for (j in 1:nm[i]) {
for (k in 1:np) {
if (i==k) gh[row,k]<-get(coef)[j]
else gh[row,k]<-get(coef)[j]*covm[i,k]
}
if (np>1) {
mat<-matrix(0,nrow=nrow(covm), ncol=ncol(covm))
for (k in 1:np) {
mat[i,k]<-get(coef)[j]*out.coeff[k]
mat[k,i]<-get(coef)[j]*out.coeff[k]
}
vy<-rep(NA, length(covariances))
row2<-1
for (k in 1:(nrow(covm)-1)) {
for (l in (k+1):nrow(covm)) {
vy[row2]<-mat[k,l]
row2<-row2+1
}
}
gh[row,(np+1):(np+length(covariances))]<-vy
}
vy<-rep(NA,np)
for (k in 1:np){
vy[k]<-out.coeff[k]*covm[i,k]
}
gh[row,np+length(covariances)+sum(nm[1:i])-nm[i]+j]<-out.coeff[i]+sum(vy)
row<-row+1
}
}

#cov(proxies,proxies)
i<-1
for (h in 1:(sum(nm))) {
col<-h
if (h>(sum(nm[1:i]))) i<-i+1
coef<-paste("prox.coeff",i, sep="")
gh[row,(np+length(covariances)+h)]<-2*get(coef)[h-(sum(nm[1:i])-nm[i])]
gh[row,(np+length(covariances)+sum(nm)+h+1)]<-2*sds[1+h]
row<-row+1
col<-col+1
if (h-(sum(nm[1:i])-nm[i])+1<=nm[i]) {
for (j in (h-(sum(nm[1:i])-nm[i])+1):nm[i]) {
gh[row,np+length(covariances)+h]<-get(coef)[j]
gh[row,np+length(covariances)+(sum(nm[1:i])-nm[i])+j]<-get(coef)[h-(sum(nm[1:i])-nm[i])]
row<-row+1
col<-col+1
}
}
if (i+1<=np) {
for (k in (i+1):np) {
coef2<-paste("prox.coeff",k, sep="")
for (l in 1:nm[k]) {
gh[row,np+(i-1)*np-i*(i-1)/2+k-i]<-get(coef)[h-(sum(nm[1:i])-nm[i])]*get(coef2)[l]
gh[row,np+length(covariances)+h]<-get(coef2)[l]*covm[i,k]
gh[row,np+length(covariances)+(sum(nm[1:k])-nm[k])+l]<-get(coef)[h-(sum(nm[1:i])-nm[i])]*covm[i,k]
row<-row+1
col<-col+1
}
}
}
}

sh<-s.hat(param,data,np,nm,cluster=cluster)

if (opt==FALSE) var.cov<-(1/N)*solve(t(gh)%*%w%*%gh)%*%t(gh)%*%w%*%sh%*%w%*%gh%*%solve(t(gh)%*%w%*%gh)
if (opt==TRUE) var.cov<-(1/N)*solve(t(gh)%*%solve(sh)%*%gh)

return(invisible(var.cov))
}


recoverols<-function(param,prox.loc,data,opt=TRUE,bootstrap=FALSE,bsiter=1000,cluster=FALSE) {

#definitions
np<-length(prox.loc)-1
nm<-rep(NA,np)
for (i in 1:np) {
nm[i]<-prox.loc[i+1]-prox.loc[i]
}

#arrange coefficients
controls<-data[,-(1:(prox.loc[np+1]-1))]
out.coeff<-param[1:np]
ifelse(np>1,covariances<-param[(np+1):((np+1)*np/2)],covariances<-vector(length=0))
covm<-diag(1, nrow=np, ncol=np)

if (np>1) {
j<-1
k<-np-1
for (i in 1:(np-1)) {
covm[i,(i+1):np]<-covariances[j:(j+k-1)]
covm[(i+1):np,i]<-covariances[j:(j+k-1)]
j<-j+k
k<-k-1
}
}

row<-(np+1)*np/2
for (i in 1:np) {
assign(paste("prox.coeff",i,sep=""),param[(row+1):(row+nm[i])])
assign(paste("prox.var",i,sep=""),param[(row+sum(nm)+2):(row+sum(nm)+1+nm[i])]^2)
row<-row+nm[i]
}

#bootstrap
if (bootstrap==TRUE) {
iter<-bsiter
store<-matrix(NA, ncol=np*max(nm), nrow=iter)
diff.bs<-rep(NA,np*max(nm))
b<-1
units<-unique(cluster)
while (b <=iter) {
if (cluster[1]==FALSE) {
draws<-ceiling(runif(nrow(data),0,nrow(data)))
sample<-data[draws,]
bsclust<-FALSE
} else {
draws<-ceiling(runif(length(units),0,length(units)))
sample<-c()
bsclust<-c()
for (j in 1:length(draws)) {
add<-data[cluster==as.vector(units[draws[j]]),]
ifelse(is.null(dim(add)),bl<-1,bl<-dim(add)[1])
bsclust<-c(bsclust,rep(j,bl))
sample<-rbind(sample,add)
}
rm(add)
}
bscontr<-sample[,-(1:(prox.loc[np+1]-1))]
bsout<-invisible(mmme(sample,prox.loc,opt=opt,var.first=FALSE,cluster=bsclust,disp=FALSE))
if (opt==TRUE){
bspar<-bsout$opt$estimate
convo<-bsout$opt$code
convf<-bsout$first$code
} else {
bspar<-bsout$first$estimate
convo<-1
convf<-bsout$first$code
}

#get difference
out.coeff.bs<-bspar[1:np]
ifelse(np>1,covariances.bs<-bspar[(np+1):((np+1)*np/2)],covariances.bs<-vector(length=0))
covm.bs<-diag(1, nrow=np, ncol=np)

if (np>1) {
j<-1
k<-np-1
for (i in 1:(np-1)) {
covm.bs[i,(i+1):np]<-covariances.bs[j:(j+k-1)]
covm.bs[(i+1):np,i]<-covariances.bs[j:(j+k-1)]
j<-j+k
k<-k-1
}
}

row<-(np+1)*np/2
for (i in 1:np) {
assign(paste("prox.coeff.bs",i,sep=""),bspar[(row+1):(row+nm[i])])
assign(paste("prox.var.bs",i,sep=""),bspar[(row+sum(nm)+2):(row+sum(nm)+1+nm[i])]^2)
row<-row+nm[i]
}

for (i in 1:max(nm)) {
coef<-diag(nrow=np)
var<-diag(nrow=np)
for (j in 1:np) {
coef[j,j]<-get(paste("prox.coeff.bs",j,sep=""))[1+(i-1)%%nm[j]]
var[j,j]<-get(paste("prox.var.bs",j,sep=""))[1+(i-1)%%nm[j]]
}
impl.ols<-solve(coef)%*%out.coeff.bs-solve(coef%*%covm.bs%*%coef+var)%*%var%*%solve(coef)%*%out.coeff.bs
pos<-rep(i-1,np)%%nm
if (ncol(bscontr)>0) {
ols<-coef(summary(lm(sample[,1]~sample[,prox.loc[1:np]+pos]+bscontr)))[2:(np+1),1:2]
} else {
ols<-coef(summary(lm(sample[,1]~sample[,prox.loc[1:np]+pos])))[2:(np+1),1:2]
}
ifelse(is.null(dim(ols))==TRUE,diff.bs[(1+(i-1)*np):(i*np)]<-impl.ols-ols[1],diff.bs[(1+(i-1)*np):(i*np)]<-impl.ols-ols[,1])
}
if (convo>2 | convf>2) {
store[b,]<-rep(NA,np*max(nm))
}else {
store[b,]<-diff.bs
}
b<-b+1
}
dist.bs<-store
suppressWarnings(store<-na.omit(matrix(as.numeric(store),dim(store))))
failure<-dim(dist.bs)[1]-dim(store)[1]
ret<-list(dist.bs=dist.bs,failure=failure)

#output
for (i in 1:max(nm)) {
coef<-diag(nrow=np)
var<-diag(nrow=np)
for (j in 1:np) {
coef[j,j]<-get(paste("prox.coeff",j,sep=""))[1+(i-1)%%nm[j]]
var[j,j]<-get(paste("prox.var",j,sep=""))[1+(i-1)%%nm[j]]
}
impl.ols<-solve(coef)%*%out.coeff-solve(coef%*%covm%*%coef+var)%*%var%*%solve(coef)%*%out.coeff
pos<-rep(i-1,np)%%nm
if (ncol(controls)>0) {
ols<-coef(summary(lm(data[,1]~data[,prox.loc[1:np]+pos]+controls)))[2:(np+1),1]
} else {
ols<-coef(summary(lm(data[,1]~data[,prox.loc[1:np]+pos])))[2:(np+1),1]
}
pval<-apply(store,2,function(z) min(c(sum(z>0)/(bsiter-failure),sum(z<0)/(bsiter-failure))))

a<-cbind(impl.ols,ols,impl.ols-ols,2*pval[(1+(i-1)*np):(i*np)])
colnames(a)<-c("Implied OLS Coeff.", "OLS Coeff.","Difference","p-value of diff.")

if (is.null(colnames(data))==FALSE) {
rownames(a)<-colnames(data)[prox.loc[1:np]+pos]
} else {
rnames<-rep(0,np)
for (j in 1:np) {
rnames[j]<-paste("LV",j,"Proxy",1+(i-1)%%nm[j])
}
rownames(a)<-rnames
} 

print(a)
if (i==1) {
b<-a
} else {
b<-rbind(b,a)
}
}
ret$results<-b
print(paste("Successful bootstrap iterations:",bsiter-failure), quote=FALSE)
print(paste("Ignored iterations (see dist.bs for details):",failure),quote=FALSE) 
return(invisible(ret))
}


if (bootstrap==FALSE) {

#arrange data
controls<-data[,-(1:(prox.loc[np+1]-1))]
ret<-list()
for (i in 1:max(nm)) {
coef<-diag(nrow=np)
var<-diag(nrow=np)
for (j in 1:np) {
coef[j,j]<-get(paste("prox.coeff",j,sep=""))[1+(i-1)%%nm[j]]
var[j,j]<-get(paste("prox.var",j,sep=""))[1+(i-1)%%nm[j]]
}
impl.ols<-solve(coef)%*%out.coeff-solve(coef%*%covm%*%coef+var)%*%var%*%solve(coef)%*%out.coeff
pos<-rep(i-1,np)%%nm
if (ncol(controls)>0) {
ols<-coef(summary(lm(data[,1]~data[,prox.loc[1:np]+pos]+controls)))[2:(np+1),1]
} else {
ols<-coef(summary(lm(data[,1]~data[,prox.loc[1:np]+pos])))[2:(np+1),1]
}

ifelse(is.null(dim(ols))==TRUE,a<-cbind(impl.ols,t(ols),impl.ols-ols[1]),a<-cbind(impl.ols,ols,impl.ols-ols[,1]))
colnames(a)<-c("Implied OLS Coeff.", "OLS Coeff.","SE","Difference")

if (is.null(colnames(data))==FALSE) {
rownames(a)<-colnames(data)[prox.loc[1:np]+pos]
} else {
rnames<-rep(0,np)
for (j in 1:np) {
rnames[j]<-paste("LV",j,"Proxy",1+(i-1)%%nm[j])
}
rownames(a)<-rnames
} 

print(a)
if(i==1) {
b<-a
} else {
b<-rbind(b,a)
}
}
ret$results<-b
if (is.null(data)==FALSE) print("Note: SE is the SE of the estimated OLS coefficient, NOT the SE of the difference.", quote=FALSE)
return(invisible(ret))
}
}

predscores<-function(param, prox.loc, data, scale=0) {
np<-length(prox.loc)-1
nm<-prox.loc[2:length(prox.loc)]-prox.loc[1:(length(prox.loc)-1)]
scores<-c()
for (i in 1:np) {
load<-param[(sum(nm[1:i])-nm[i]+1+np+(np-1)*np/2):(sum(nm[1:i])+np+(np-1)*np/2)]
v<-(param[(np+(np-1)*np/2+sum(nm)+sum(nm[1:i])-nm[i]+1):(np+(np-1)*np/2+sum(nm)+sum(nm[1:i]))])^2
scores<-cbind(scores,t(solve(t(load)%*%diag(1/v)%*%load)%*%t(load)%*%diag(1/v)%*%t(data[,prox.loc[i]:(prox.loc[i+1]-1)])))
}
if (scale!=0) ifelse(np==1,scores<-(-1)*scores,scores<-scores%*%diag(scale))
return(scores)
}

